-- Old Instance Finder - DrKazza

--Declare Addon and libraries
local OIF = LibStub("AceAddon-3.0"):NewAddon("OldInstanceFinder", "AceConsole-3.0")
local GUI = LibStub("AceGUI-3.0") 
local wholib = LibStub:GetLibrary("LibWho-2.0"):Library()
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local BF = LibStub("LibBabble-Faction-3.0"):GetLookupTable() 
local L = LibStub("AceLocale-3.0"):GetLocale("OldInstanceFinder")
local defaultsearch = "80+" -- Default max level to search for
local maxlevel = 85
LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("OldInstanceFinder", {
	type = "launcher",
	text = "OIF",
	icon = "Interface\\Icons\\Ability_Tracking",
	OnClick = function(clickedframe, button)
	    OIF:BuildMainDisplay() 
	end,
})


local defaults = {
	profile = {
		DungeonList = {
		   [1] = { ["name"] = BZ["Ragefire Chasm"],               ["dosearch"] =false,       ["level"] = 16 ,       ["reason"] =L["Achievement"]},
		   [2] = { ["name"] = BZ["Wailing Caverns"],          ["dosearch"] =false,       ["level"] = 18 ,       ["reason"] =L["Achievement"]},
		   [3] = { ["name"] = BZ["The Deadmines"],                ["dosearch"] =false,       ["level"] = 20 ,       ["reason"] =L["Achievement"]},
		   [4] = { ["name"] = BZ["Shadowfang Keep"],          ["dosearch"] =false,       ["level"] = 22 ,       ["reason"] =L["Achievement"]},
		   [5] = { ["name"] = BZ["Blackfathom Deeps"],             ["dosearch"] =false,       ["level"] = 24 ,       ["reason"] =L["Achievement"]},
		   [6] = { ["name"] = BZ["The Stockade"],                 ["dosearch"] =false,       ["level"] = 25 ,       ["reason"] =L["Achievement"]},
		   [7] = { ["name"] = BZ["Gnomeregan"],                ["dosearch"] =false,       ["level"] = 30 ,       ["reason"] =L["Achievement"]},
		   [8] = { ["name"] = BZ["Razorfen Kraul"],                ["dosearch"] =false,       ["level"] = 35 ,       ["reason"] =L["Achievement"]},
		   [9] = { ["name"] = BZ["Scarlet Monastery"],            ["dosearch"] =false,       ["level"] = 36,       ["reason"] =L["Achievement"]},
		   [10] = { ["name"] = BZ["Maraudon"],                 ["dosearch"] =false,       ["level"] = 37 ,       ["reason"] =L["Achievement"]},
		   [11] = { ["name"] = BZ["Uldaman"],                  ["dosearch"] =false,       ["level"] = 40 ,       ["reason"] =L["Achievement"]},
		   [12] = { ["name"] = BZ["Scholomance"],              ["dosearch"] =false,       ["level"] = 43 ,       ["reason"] =BF["Argent Dawn"]},
		   [13] = { ["name"] = BZ["Zul'Farrak"],               ["dosearch"] =false,       ["level"] = 44 ,       ["reason"] =L["Achievement"]},
		   [14] = { ["name"] = BZ["Razorfen Downs"],                ["dosearch"] =false,       ["level"] = 45 ,       ["reason"] =L["Achievement"]},
		   [15] = { ["name"] = BZ["Dire Maul"],                ["dosearch"] =false,       ["level"] = 45 ,       ["reason"] =L["Achievement"]},
		   [16] = { ["name"] = BZ["Stratholme"],               ["dosearch"] =false,       ["level"] = 50 ,       ["reason"] =BF["Argent Dawn"]},
		   [17] = { ["name"] = BZ["Blackrock Depths"],             ["dosearch"] =false,       ["level"] = 54 ,       ["reason"] =L["Achievement"]},
		   [18] = { ["name"] = BZ["The Temple of Atal'Hakkar"],        ["dosearch"] =false,       ["level"] = 55 ,       ["reason"] =L["Achievement"]},
		   [19] = { ["name"] = BZ["Blackrock Spire"],          ["dosearch"] =false,       ["level"] = 57 ,       ["reason"] =L["Achievement"]},
		   [20] = { ["name"] = BZ["Zul'Gurub"],                ["dosearch"] =false,       ["level"] = 59 ,       ["reason"] =BF["Zandalar Tribe"]},
		   [21] = { ["name"] = BZ["Molten Core"],              ["dosearch"] =true,       ["level"] = 60 ,       ["reason"] =BF["Hydraxian Waterlords"]},
		   [22] = { ["name"] = BZ["Blackwing Lair"],           ["dosearch"] =true,       ["level"] = 60 ,       ["reason"] =L["Achievement"]},
		   [23] = { ["name"] = BZ["Ruins of Ahn'Qiraj"],           ["dosearch"] =false,       ["level"] = 60 ,       ["reason"] =BF["Cenarion Circle"].." & "..BF["Brood of Nozdormu"]},
		   [24] = { ["name"] = BZ["Temple of Ahn'Qiraj"],          ["dosearch"] =true,       ["level"] = 60 ,       ["reason"] =BF["Brood of Nozdormu"]},
		   [25] = { ["name"] = BZ["Hellfire Ramparts"],            ["dosearch"] =true,       ["level"] = 61 ,       ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"]},
		   [26] = { ["name"] = BZ["The Blood Furnace"],            ["dosearch"] =true,       ["level"] = 62 ,       ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"]},
		   [27] = { ["name"] = BZ["The Slave Pens"],           ["dosearch"] =false,       ["level"] = 62 ,       ["reason"] =BF["Cenarion Expedition"]},
		   [28] = { ["name"] = BZ["The Underbog"],                 ["dosearch"] =false,       ["level"] = 64 ,       ["reason"] =BF["Cenarion Expedition"]},
		   [29] = { ["name"] = BZ["Mana-Tombs"],               ["dosearch"] =false,       ["level"] = 65 ,       ["reason"] =BF["The Consortium"]},
		   [30] = { ["name"] = BZ["Auchenai Crypts"],          ["dosearch"] =true,       ["level"] = 66 ,       ["reason"] =BF["Lower City"]},
		   [31] = { ["name"] = BZ["Old Hillsbrad Foothills"],      ["dosearch"] =true,       ["level"] = 67 ,       ["reason"] =BF["Keepers of Time"]},
		   [32] = { ["name"] = BZ["Sethekk Halls"],                ["dosearch"] =true,       ["level"] = 68 ,       ["reason"] =BF["Lower City"]},
		   [33] = { ["name"] = BZ["The Steamvault"],               ["dosearch"] =false,       ["level"] = 69 ,       ["reason"] =BF["Cenarion Expedition"]},
		   [34] = { ["name"] = BZ["Shadow Labyrinth"],             ["dosearch"] =true,       ["level"] = 69 ,       ["reason"] =BF["Lower City"]},
		   [35] = { ["name"] = BZ["The Shattered Halls"],          ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"]},
		   [36] = { ["name"] = BZ["The Black Morass"],             ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["Keepers of Time"]},
		   [37] = { ["name"] = BZ["The Botanica"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["The Sha'tar"]},
		   [38] = { ["name"] = BZ["The Mechanar"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["The Sha'tar"]},
		   [39] = { ["name"] = BZ["The Arcatraz"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["The Sha'tar"]},
		   [40] = { ["name"] = BZ["Magisters' Terrace"],           ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [41] = { ["name"] = BZ["Karazhan"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["The Violet Eye"]},
		   [42] = { ["name"] = BZ["Gruul's Lair"],                 ["dosearch"] =false,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [43] = { ["name"] = BZ["Magtheridon's Lair"],           ["dosearch"] =false,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [44] = { ["name"] = BZ["Zul'Aman"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [45] = { ["name"] = BZ["Serpentshrine Cavern"],         ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [46] = { ["name"] = BZ["Tempest Keep"],                  ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [47] = { ["name"] = BZ["Hyjal Summit"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["The Scale of the Sands"]},
		   [48] = { ["name"] = BZ["Black Temple"],                 ["dosearch"] =true,       ["level"] = 70 ,       ["reason"] =BF["Ashtongue Deathsworn"]},
		   [49] = { ["name"] = BZ["Sunwell Plateau"],          ["dosearch"] =false,       ["level"] = 70 ,       ["reason"] =L["Achievement"]},
		   [50] = { ["name"] = BZ["Utgarde Keep"],                 ["dosearch"] =false,       ["level"] = 71 ,       ["reason"] =L["Achievement"]},
		   [51] = { ["name"] = BZ["The Nexus"],                ["dosearch"] =false,       ["level"] = 72 ,       ["reason"] =L["Achievement"]},
		   [52] = { ["name"] = BZ["Azjol-Nerub"],              ["dosearch"] =false,       ["level"] = 73 ,       ["reason"] =L["Achievement"]},
		   [53] = { ["name"] = BZ["Ahn'kahet: The Old Kingdom"],   ["dosearch"] =false,       ["level"] = 74 ,       ["reason"] =L["Achievement"]},
		   [54] = { ["name"] = BZ["Drak'Tharon Keep"],             ["dosearch"] =false,       ["level"] = 75 ,       ["reason"] =L["Achievement"]},
		   [55] = { ["name"] = BZ["The Violet Hold"],          ["dosearch"] =false,       ["level"] = 76 ,       ["reason"] =L["Achievement"]},
		   [56] = { ["name"] = BZ["Gundrak"],                  ["dosearch"] =false,       ["level"] = 77 ,       ["reason"] =L["Achievement"]},
		   [57] = { ["name"] = BZ["Halls of Stone"],           ["dosearch"] =false,       ["level"] = 78 ,       ["reason"] =L["Achievement"]},
		   [58] = { ["name"] = BZ["Halls of Lightning"],           ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [59] = { ["name"] = BZ["The Oculus"],               ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [60] = { ["name"] = BZ["The Culling of Stratholme"],        ["dosearch"] =false,       ["level"] = 80,       ["reason"] =L["Achievement"]},
		   [61] = { ["name"] = BZ["Utgarde Pinnacle"],             ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [62] = { ["name"] = BZ["Trial of the Champion"],        ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [63] = { ["name"] = BZ["The Forge of Souls"],           ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [64] = { ["name"] = BZ["Pit of Saron"],                 ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [65] = { ["name"] = BZ["Halls of Reflection"],          ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [66] = { ["name"] = BZ["Naxxramas"],                ["dosearch"] =true,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [67] = { ["name"] = BZ["The Obsidian Sanctum"],         ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [68] = { ["name"] = BZ["The Eye of Eternity"],          ["dosearch"] =false,       ["level"] = 80,       ["reason"] =L["Achievement"]},
		   [69] = { ["name"] = BZ["Onyxia's Lair"],                ["dosearch"] =true,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [70] = { ["name"] = BZ["Ulduar"],                   ["dosearch"] =true,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [71] = { ["name"] = BZ["Trial of the Crusader"],        ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [72] = { ["name"] = BZ["Vault of Archavon"],            ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [73] = { ["name"] = BZ["Icecrown Citadel"],             ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =BF["The Ashen Verdict"]},
		   [74] = { ["name"] = BZ["The Ruby Sanctum"],             ["dosearch"] =false,       ["level"] = 80 ,       ["reason"] =L["Achievement"]},
		   [75] = { ["name"] = BZ["Throne of the Tides"],             ["dosearch"] =false,       ["level"] = 81 ,       ["reason"] =L["Achievement"]},
		   [76] = { ["name"] = BZ["Blackrock Caverns"],             ["dosearch"] =false,       ["level"] = 81 ,       ["reason"] =L["Achievement"]},
		   [77] = { ["name"] = BZ["The Vortex Pinnacle"],             ["dosearch"] =false,       ["level"] = 82 ,       ["reason"] =L["Achievement"]},
		   [78] = { ["name"] = BZ["The Stonecore"],             ["dosearch"] =false,       ["level"] = 83 ,       ["reason"] =L["Achievement"]},
		   [79] = { ["name"] = BZ["Lost City of the Tol'vir"],             ["dosearch"] =false,       ["level"] = 84 ,       ["reason"] =L["Achievement"]},
		   [80] = { ["name"] = BZ["Halls of Origination"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		   [81] = { ["name"] = BZ["Grim Batol"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		   [82] = { ["name"] = BZ["Baradin Hold"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		   [83] = { ["name"] = BZ["The Bastion of Twilight"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		   [84] = { ["name"] = BZ["Throne of the Four Winds"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		   [85] = { ["name"] = BZ["Blackwing Descent"],             ["dosearch"] =false,       ["level"] = 85 ,       ["reason"] =L["Achievement"]},
		}
	      }
	}

-- -------------------------------------------------------
-- Create the main window and the spacing
-- -------------------------------------------------------
local oifdisplay
local cbwidth = 30
local namewidth = 225
local lvlwidth = 75
local reasonwidth = 225 
local db
local textentered

-- -------------------------------------------------------
function OIF:OnInitialize() 
-- -------------------------------------------------------
    OIF:RegisterChatCommand("OIF", "Slash")
    OIF:RegisterChatCommand("OldInstanceFinder", "Slash")
    OIF.db = LibStub("AceDB-3.0"):New("OIFDB", defaults)
    db = OIF.db.profile
end

-- -------------------------------------------------------
function OIF:Enable() 
-- -------------------------------------------------------
   oifdisplay:Hide()
	
end 


-- -------------------------------------------------------
function OIF:Slash(msg)
-- -------------------------------------------------------
  if msg == "" or nil then 
    OIF:BuildMainDisplay() 
  else
    OIF:cmdlinesearch(msg)
  end
end

-- -------------------------------------------------------
function OIF:cmdlinesearch(msg)
-- -------------------------------------------------------
        if tonumber(msg) then
		-- Arguement is a number, searching for a specific level
            OIF:StartSearch(msg)
            return;
	  else 
		local lookforplus = string.find(msg, "%+")
		if lookforplus then
			-- Arguement has a + so look for the digits preceeding it and search to max level
			_, _, minlevel = string.find(msg, "(%d+)%+")
			if tonumber(minlevel) then
		            OIF:StartSearch(minlevel, maxlevel)
            		    return;
			else
				-- The digits preceeding the + were not a number - return usage message
			      OIF:Usage()
			end
		end

		local lookforminus = string.find(msg, "%-")
		local lowerlvl
		local upperlvl
		if lookforminus then
			-- Arguement has a - so look for the digits preceeding and following it
			_, _, lowerlvl, upperlvl = string.find(msg, "(%d+)%-(%d+)")
			if tonumber(lowerlvl) and tonumber(upperlvl) then
		            OIF:StartSearch(lowerlvl, upperlvl)				
            		    return;
			else
				-- The digits preceeding and following the - were not numbers - return usage message
			      OIF:Usage()
			end
		end
        end
end

-- -------------------------------------------------------
function OIF:Usage()
-- -------------------------------------------------------
    OIF:Print(L["Usage"])
end


local isranged
-- -------------------------------------------------------
function OIF:StartSearch(a, ...)
-- -------------------------------------------------------

if ... then
	isranged = true
	lvlstring = a.."-".. ...
else
	-- only one arguement passed therefore search for one level only
	isranged = false
	lvlstring = a
end

local searchessent = 0

    for i=1, #db.DungeonList do
        if db.DungeonList[i]["dosearch"] then
           searchquery = 'z-'..db.DungeonList[i]["name"]..' '..lvlstring

           local searchresult = wholib:Who(
           searchquery,
           {
           queue = wholib.WHOLIB_QUEUE_SCANNING,
           --flags = whoLib.WHOLIB_FLAG_ALWAYS_CALLBACK,   -- not sure what this does but it works without it!
           callback = self.CatchWhoResults
           });
           if(searchresult) then
                self.CatchWhoResults(searchresult);
           end
        searchessent = searchessent + 1
	end
    end
    OIF:Print((L["Startsearch"]):format(searchessent))
end

-- -------------------------------------------------------
function OIF:CatchWhoResults(results, complete)
-- -------------------------------------------------------
    if results == nil or #results == 0 then
        -- no one in this dungeon
    else
        currentzone = results[1].Zone;
        level = results[1].Level;
        numofrunners = #results;

		if complete then
			if numofrunners == 1 then
				OIF:Print((L["OneHit"]) :format(level, currentzone));
			else
				if isranged then
					OIF:Print((L["MoreHitsRange"]) :format(numofrunners, currentzone))
				else
					OIF:Print((L["MoreHits"]) :format(numofrunners, level, currentzone))
				end
			end
		else
			if isranged then
				OIF:Print((L["LotsHitsRange"]) :format(currentzone))
			else
				OIF:Print((L["LotsHits"]) :format(level, currentzone))
			end
		end
    end
end



-- -------------------------------------------------------
function OIF:RefreshDisplay() 
-- -------------------------------------------------------
    OIF:BuildMainDisplay() 
end 


-- -------------------------------------------------------
function OIF:BuildMainDisplay() 
-- -------------------------------------------------------
   if oifdisplay and oifdisplay:IsVisible() then 
      oifdisplay:Hide() 
      return 
   end 


   oifdisplay = GUI:Create("Frame");
--set global name
   _G["OIF_display"] = oifdisplay
--use escape to close
   tinsert(UISpecialFrames, "OIF_display")

   local dscroll = GUI:Create("ScrollFrame");

   oifdisplay:SetTitle(L["Old Instance Finder"]) 
   oifdisplay:SetLayout("Flow") 
   oifdisplay:SetStatusTable{width=800} 

-- This bit stops the window being resized but the functionality was removed from AceGUI-3.0
--   oifdisplay.sizer_se:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_se:SetScript("OnMouseUp",nil) 
--   oifdisplay.sizer_s:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_s:SetScript("OnMouseUp",nil) 
--   oifdisplay.sizer_e:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_e:SetScript("OnMouseUp",nil) 

   oifdisplay:SetCallback("OnClose", function(_oifdisplay) 
      GUI:Release(_oifdisplay) 
   end) 


   local titlesg = GUI:Create("SimpleGroup") 
   titlesg:SetLayout("Flow")
   titlesg:SetHeight(100)
   titlesg:SetFullWidth(true)

   local titlegap = GUI:Create("Label")
   titlegap:SetWidth(cbwidth)
   titlegap:SetText(" ")

   local titledung = GUI:Create("Label")
   titledung:SetWidth(namewidth)
   titledung:SetText(L["Dungeon/Instance/Raid:"])

   local titlelvl = GUI:Create("Label")
   titlelvl:SetWidth(lvlwidth)
   titlelvl:SetText(L["Level:"])

   local titlereason = GUI:Create("Label")
   titlereason:SetWidth(reasonwidth)
   titlereason:SetText(L["Faction/Purpose:"])

   titlesg:AddChildren(titlegap, titledung, titlelvl, titlereason)

 
   oifdisplay:AddChild(titlesg) 

-- this bit creates a space below the title area, layout aesthetics
   local minispacer = GUI:Create("SimpleGroup")
   minispacer:SetLayout("Flow")
   minispacer:SetHeight(100)
   minispacer:SetFullWidth(true)
   local minigap = GUI:Create("Label")
   minigap:SetFullWidth(true)
   minigap:SetText(" ")
   minispacer:AddChild(minigap)
   oifdisplay:AddChild(minispacer) 



-- Create a pair of Inline groups to sit inside it
   local rhswidth = 0.2

   local lhs_sg = GUI:Create("SimpleGroup") 
   lhs_sg:SetLayout("Fill")
   lhs_sg:SetRelativeWidth(0.99-rhswidth) 
   lhs_sg:SetFullHeight(true)

   local rhs_sg = GUI:Create("SimpleGroup");
   rhs_sg:SetLayout("Flow");
   rhs_sg:SetRelativeWidth(rhswidth);
   rhs_sg.alignoffset = 25

-- Add the Easy Stuff to the Right Hand Side
local h1, h2, sp1, sp2, edbox, bsearch, bload, bsave, bclear, htext

-- Header above search button 
   h1 = GUI:Create("Heading") 
   h1:SetFullWidth(true) 
   h1:SetText(L["Run Search"]) 
   rhs_sg:AddChild(h1) 
 
-- Edit box for level search 
   local edbox = GUI:Create("EditBox") 
   edbox:SetRelativeWidth(1) 
   if textentered then 
      edbox:SetText(textentered) 
   else
      edbox:SetText(defaultsearch) 
   end
   edbox:SetCallback("OnEnterPressed", function(_b, _event, text) 
--      OIF:Print("Text Entry... "..text.." run the search now")
	textentered = text
   end) 
   rhs_sg:AddChild(edbox) 
 
-- Search button 
   bsearch = GUI:Create("Button") 
   bsearch:SetText(L["Search"]) 
   bsearch:SetRelativeWidth(1) 
   bsearch:SetCallback("OnClick", function() 
	if textentered then
	      OIF:cmdlinesearch(textentered)
	else
	      OIF:cmdlinesearch(defaultsearch) 
	end
      oifdisplay:Hide() 
   end) 
   rhs_sg:AddChild(bsearch) 

-- help text
   local htext = GUI:Create("Label")
   htext:SetRelativeWidth(1)
   htext:SetText(L["Help Text"])
   rhs_sg:AddChild(htext)


--  Leave a gap
   sp1 = GUI:Create("Spacer")
   sp1:SetFullWidth(true)
   sp1:SetHeight(50)
   rhs_sg:AddChild(sp1)
 
--  Saving Preferences and Clearing selections 
   h2 = GUI:Create("Heading") 
   h2:SetFullWidth(true) 
   h2:SetText(L["Preferences"]) 
   rhs_sg:AddChild(h2) 
 
--[[
--  Save Button 
   bsave = GUI:Create("Button") 
   bsave:SetText(L["Save Selection"]) 
   bsave:SetRelativeWidth(1) 
   bsave:SetCallback("OnClick", function() 
       OIF.db.profile.DungeonList = db.DungeonList
--       OIF:Print("Save To SV") 
   end) 
   rhs_sg:AddChild(bsave) 
]]
 
--  Load Button 
   bload = GUI:Create("Button") 
   bload:SetText(L["Load Defaults"]) 
   bload:SetRelativeWidth(1) 
   bload:SetCallback("OnClick", function() 
       db.DungeonList = defaults.profile.DungeonList
	 oifdisplay:Hide()
--       OIF:Print("Load From SV")
	OIF:RefreshDisplay()
	return 
	 -- yeah annoying isn't it... 
       -- however I don't know how to refresh the checkbox selections so I've got to rebuild the whole bloody thing!
   end) 
   rhs_sg:AddChild(bload) 

-- Leave a gap
   sp2 = GUI:Create("Spacer")
   sp2:SetFullWidth(true)
   sp2:SetHeight(50)
   rhs_sg:AddChild(sp2)
 
--  Clear All Button 
   bclear = GUI:Create("Button") 
   bclear:SetText(L["Clear All"]) 
   bclear:SetFullWidth(true) 
   bclear:SetCallback("OnClick", function() 

	for i=1, #db.DungeonList do
        db.DungeonList[i]["dosearch"] = false
	end
	
--	OIF:Print("Clearing all Dungeons") 
	oifdisplay:Hide()
	OIF:RefreshDisplay()
	return 
      -- see load button for pitiful excuses
   end) 
   rhs_sg:AddChild(bclear) 
--  don't care about putting a warning, if people clear and save then it'll only take a few seconds to repopulate. 




--  Left Hand Panel Scrolling Dungeon Selector 
   local sf = GUI:Create("ScrollFrame"); 
   sf:SetLayout("List")

 
--  Start adding the list of dungeons, each with its own checkbox 
   local searchbool, dungeonname, levelstr, reason
	for i=1, #db.DungeonList do

-- add a block for the contents.
      local entryline = GUI:Create("SimpleGroup")
      entryline:SetRelativeWidth(0.99)
	entryline:SetHeight(15)
	entryline:SetLayout("Flow")

       local cb = GUI:Create("CheckBox")
	cb:SetType("checkbox")
        cb:SetWidth(cbwidth)
	searchbool = db.DungeonList[i]["dosearch"]
	cb:SetValue(searchbool)
         OIF:CheckBoxDefinition(cb, i)
         -- yes I did it... don't even go there!
	entryline:AddChild(cb)

-- Dungeon Name
      local dungname = GUI:Create("Label")
	dungname:SetWidth(namewidth)
	dungeonname = db.DungeonList[i]["name"]
	dungname:SetText(dungeonname)
	entryline:AddChild(dungname)

-- Level recommendation
      local lvlrec = GUI:Create("Label")
	lvlrec:SetWidth(lvlwidth)
	levelstr = db.DungeonList[i]["level"]
	lvlrec:SetText(levelstr)
	entryline:AddChild(lvlrec)

-- Reason
      local dreason = GUI:Create("Label")
	dreason:SetWidth(reasonwidth)
	reason = db.DungeonList[i]["reason"]
	dreason:SetText(reason)
	entryline:AddChild(dreason)



	sf:AddChild(entryline)
   end 

   lhs_sg:AddChild(sf) 
   oifdisplay:AddChild(lhs_sg)
   oifdisplay:AddChild(rhs_sg) 
   sf:ResumeLayout() 
   oifdisplay:ResumeLayout() 
   oifdisplay:ApplyStatus() 
   return oifdisplay 
end 


-- -------------------------------------------------------
-- Checkbox function allocation
-- -------------------------------------------------------
function OIF:CheckBoxDefinition(chkbx, n)
   chkbx:SetCallback("OnValueChanged", function(cb, event, value)
      db.DungeonList[n]["dosearch"] = value
      end)

end

